Name: openssl
Version: 1.0.2q
Release: 0
License: OpenSSL
Summary: Open Source SSL/TLS toolkit
Url: https://www.openssl.org

BuildRequires: zlib-devel
BuildRequires: ibm-build-tools

Source0: https://www.openssl.org/source/openssl-%{version}.tar.gz

# Patch0: config.patch
Patch1: Configure.patch
Patch2: e_os2.h.patch
Patch3: ui_Makefile.patch
Patch4: ui_openssl.c.patch
Patch5: ui_pase.c.patch
Patch6: UPSTREAM_1.1_CVE-2016-2183.patch

%description
OpenSSL is an open source project that provides a robust, commercial-grade, and full-featured toolkit for the Transport Layer Security (TLS) and Secure Sockets Layer (SSL) protocols. It is also a general-purpose cryptography library. For more information about the team and community around the project, or to start making your own contributions, start with the community page. To get the latest news, download the source, and so on, please see the sidebar or the buttons at the top of every page.

%package -n libopenssl1_0_0
Summary: OpenSSL 1.0.x library

%description -n libopenssl1_0_0
OpenSSL is an open source project that provides a robust, commercial-grade, and full-featured toolkit for the Transport Layer Security (TLS) and Secure Sockets Layer (SSL) protocols. It is also a general-purpose cryptography library. For more information about the team and community around the project, or to start making your own contributions, start with the community page. To get the latest news, download the source, and so on, please see the sidebar or the buttons at the top of every page.

%package devel
Summary: OpenSSL development files
Requires: libopenssl1_0_0 >= %{version}

%description devel
OpenSSL is an open source project that provides a robust, commercial-grade, and full-featured toolkit for the Transport Layer Security (TLS) and Secure Sockets Layer (SSL) protocols. It is also a general-purpose cryptography library. For more information about the team and community around the project, or to start making your own contributions, start with the community page. To get the latest news, download the source, and so on, please see the sidebar or the buttons at the top of every page.



%prep
%setup -q

# %patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build

%ifarch ppc64
OBJECT_MODE=64; export OBJECT_MODE;
%else
OBJECT_MODE=32; export OBJECT_MODE;
%endif

perl ./Configure \
%ifarch ppc64
  pase64-gcc \
%else
  pase-gcc \
%endif
  zlib-dynamic \
  no-fips \
  no-idea \
  no-mdc2 \
  no-rc5 \
  no-engines \
  shared \
  threads \
  --prefix=%{_prefix} \
  --openssldir=/QOpenSys/etc/ssl \
  -L%{_libdir} \
  -I%{_includedir} \
  -Wl,-brtl \
  -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib

# TODO: Make this in to a patch
perl -p -i -e '/LD_LIBRARY_PATH=/d' Makefile.shared

make depend

# %make_build

# OpenSSL 1.0.* libcrypto.so depends on fips_premain_dso,
# but the rule doesn't actually build if we're not building
# FIPS support... Since it doesn't get built, that triggers
# libcrypto.so to get rebuilt every time
touch fips_premain_dso

make build_libs
# make libcrypto.so.1.0.0
svr4-shrlib libcrypto.so.1.0.0 libcrypto.so.1.0.0 %{_arch}

rm libssl.so.1.0.0
make libssl.so.1.0.0
svr4-shrlib libssl.so.1.0.0 libssl.so.1.0.0 %{_arch}

# rm apps/openssl
%make_build

perl -p -i -e 's|#!/usr/bin/perl|#!%{_bindir}/perl|' apps/tsget


%install

%make_build INSTALL_PREFIX=%{buildroot} install

rm %{buildroot}/%{_libdir}/*.a
rm -r %{buildroot}/%{_libdir}/engines

mkdir -p %{buildroot}/%{_mandir}
mv %{buildroot}/QOpenSys/etc/ssl/man/* %{buildroot}/%{_mandir}
rmdir %{buildroot}/QOpenSys/etc/ssl/man

mkdir -p %{buildroot}/%{_datadir}/ssl
mv %{buildroot}/QOpenSys/etc/ssl/misc %{buildroot}/%{_datadir}/ssl


%files
%defattr(-, qsys, *none)

%{_bindir}/openssl
%{_bindir}/c_rehash

%{_datadir}/ssl
%{_mandir}/man1/*

/QOpenSys/etc/ssl

%files -n libopenssl1_0_0
%defattr(-, qsys, *none)

# %{_libdir}/engines/*.so

%{_libdir}/libcrypto.so.*
%{_libdir}/libssl.so.*


%files devel
%defattr(-, qsys, *none)

%{_libdir}/libcrypto.so
%{_libdir}/libssl.so

%{_libdir}/pkgconfig/*

%{_mandir}/man3/*
%{_mandir}/man5/*
%{_mandir}/man7/*

%{_includedir}/openssl

%changelog
